CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

VAR
  long  cmd                                             ' command for asm cog
  long  paramL1                                         ' parameter for asm cog

OBJ
  terminal : "simple_serial"                            ' create serial object
  myVal    : "numbers"                                  ' create formattable number object

PUB Main
  cmd := 0
  cognew(@ASM, @cmd)                                    ' launch new cog with assembly code

  terminal.Init(31, 30, 19200)                          ' initialize terminal
  myVal.Init                                            ' initialize numbers object

  terminal.tx(12)                                       ' like CLS for HyperTerminal
  terminal.str(myVal.tostr(incval(100), myVal#DDEC))
  terminal.tx(13)
  terminal.str(myVal.tostr(decval(1000), myVal#DDEC))

  repeat                                                ' stop here until reset

PUB incval(val) : result
  paramL1 := val                                        ' campture parameter for cog
  cmd := 1                                              ' set command
  repeat while cmd <> 0                                 ' let cog finish
  result := paramL1                                     ' return updated value

PUB decval(val) : result
  paramL1 := val
  cmd := 2
  repeat while cmd <> 0
  result := paramL1


DAT

              org       0

ASM           mov       cmdAddr, par                    ' get command address
              mov       valAddr, par                    ' make copy
              add       valAddr, #4                     ' adjust for value address

WaitForCmd    rdlong    tmpL1, cmdAddr                  ' move command to tmpL1
              tjz       tmpL1, #WaitForCmd              ' wait if no command (cmd = 0)

CheckCmd      cmp       tmpL1, #1    wz
        if_z  jmp       #Increment
              cmp       tmpL1, #2    wz
        if_z  jmp       #Decrement

BadCmd        wrlong    zero, cmdAddr                   ' clear command
              jmp       #WaitForCmd

Increment     rdlong    tmpL1, valAddr                  ' copy value
              add       tmpL1, #1                       ' increment
              wrLong    tmpL1, valAddr                  ' write it back
              wrLong    zero, cmdAddr                   ' clear command
              jmp       #WaitForCmd

Decrement     rdlong    tmpL1, valAddr                  ' copy value
              sub       tmpL1, #1                       ' decrement
              wrLong    tmpL1, valAddr                  ' write it back
              wrLong    zero, cmdAddr                   ' clear command
              jmp       #WaitForCmd

' ENDASM


cmdAddr       long      0                               ' address of command value
valAddr       long      0                               ' address of value to manipulate

tmpL1         long      0                               ' workspace                      '
zero          long      0